searchNodes=[{"doc":"Use AbacusSql to introduce powerful customizable query features to your application. By leveraging the safe to execute expression syntax of Abacus, Ecto queries can be modified with filters (via where/3), additional custom selects, custom order_by clauses, and more. Examples from ( u in User , group_by : u . id ) |&gt; AbacuSql . where ( ~S[name == &quot;Peter&quot;] ) ) |&gt; AbacusSql . select ( &quot;name&quot; , &quot;name&quot; ) # blog_posts assoc is automatically joined |&gt; AbacusSql . select ( &quot;post_count&quot; , &quot;count(blog_posts.id)&quot; ) |&gt; AbacusSql . order_by ( &quot;name&quot; , true ) # take a filter from plug params from ( u in User ) |&gt; where ( Map . get ( params , &quot;filter&quot; , &quot;true&quot; ) )","ref":"AbacusSql.html","title":"AbacusSql","type":"module"},{"doc":"Adds a group_by expression to the query","ref":"AbacusSql.html#group_by/3","title":"AbacusSql.group_by/3","type":"function"},{"doc":"Adds the given filter to the havings list. Make sure that the query has at least one group_by clause. The advantage is that it can filter inside has_many assocs using aggregation such as count , min or max . For example: having(BlogPost, &quot;count(author.posts.id) &gt; 10&quot;) would filter for blog posts whose authors have at least 10 posts.","ref":"AbacusSql.html#having/3","title":"AbacusSql.having/3","type":"function"},{"doc":"Adds an order_by expression to the query.","ref":"AbacusSql.html#order_by/4","title":"AbacusSql.order_by/4","type":"function"},{"doc":"","ref":"AbacusSql.html#order_by_alias/3","title":"AbacusSql.order_by_alias/3","type":"function"},{"doc":"","ref":"AbacusSql.html#order_by_index/3","title":"AbacusSql.order_by_index/3","type":"function"},{"doc":"Adds scoped data to the query. That data is accessible by simply accessing the given key. Example: from ( u in User ) |&gt; AbacusSql . scope ( some_number : 13 ) |&gt; AbacusSql . where ( &quot;count(blog_posts.id) &lt; some_number&quot; )","ref":"AbacusSql.html#scope/2","title":"AbacusSql.scope/2","type":"function"},{"doc":"Adds scoped data to the query. That data is accessible by simply accessing the given key. Example: from ( u in User ) |&gt; AbacusSql . scope ( :some_number , 13 ) |&gt; AbacusSql . where ( &quot;count(blog_posts.id) &lt; some_number&quot; )","ref":"AbacusSql.html#scope/3","title":"AbacusSql.scope/3","type":"function"},{"doc":"Adds or merges a selection to the query. Options: as - if set, will wrap the expression with the fragment &quot;? AS \#{name}&quot;. Only letters, digits, - and _ are allowed, the function will raise otherwise. root - if set, will use the given alias as the root table Example: query = from u in User query = select ( query , &quot;name&quot; , ~S[concat(name, &quot; (&quot;, count(blog_posts.id), &quot; posts)&quot;)] ) Repo . all ( query ) == [ %{ &quot;name&quot; =&gt; &quot;Peter (31 posts)&quot; } , %{ &quot;name&quot; =&gt; &quot;Mark (13 posts)&quot; } ]","ref":"AbacusSql.html#select/4","title":"AbacusSql.select/4","type":"function"},{"doc":"Selects the given terms as a list. Example: query = from u in User query = select ( query , [ &quot;name&quot; , &quot;count(blog_posts.id)&quot; ] ) Repo . all ( query ) == [ [ &quot;Peter&quot; , 31 ] , [ &quot;Mark&quot; , 13 ] ]","ref":"AbacusSql.html#select_list/3","title":"AbacusSql.select_list/3","type":"function"},{"doc":"Adds an and_where clause to the query.","ref":"AbacusSql.html#where/3","title":"AbacusSql.where/3","type":"function"},{"doc":"","ref":"AbacusSql.html#t:option/0","title":"AbacusSql.option/0","type":"type"},{"doc":"","ref":"AbacusSql.html#t:options/0","title":"AbacusSql.options/0","type":"type"},{"doc":"Default: 0 Specifies which source in the query should be used as root. It can either be given as a table id (0 is the actual root, 1-n is the first-nth join), or as an alias. The expressions will then have the given source as their root, meaning their fields and assocs are directly accessible. Example: query = from u in User , join bp in assoc ( u , :blog_posts ) , as : :blog_posts AbacusSql . where ( query , &quot;title != null&quot; , root : :blog_posts ) otherwise we'd have to write the where expression like this: query = from u in User , join bp in assoc ( u , :blog_posts ) AbacusSql . where ( query , &quot;blog_posts.title != null&quot; )","ref":"AbacusSql.html#t:root_option/0","title":"AbacusSql.root_option/0","type":"type"},{"doc":"","ref":"AbacusSql.html#t:t/0","title":"AbacusSql.t/0","type":"type"},{"doc":"","ref":"AbacusSql.AstUtil.html","title":"AbacusSql.AstUtil","type":"module"},{"doc":"","ref":"AbacusSql.AstUtil.html#join_right_operator/2","title":"AbacusSql.AstUtil.join_right_operator/2","type":"function"},{"doc":"","ref":"AbacusSql.Completable.html","title":"AbacusSql.Completable","type":"behaviour"},{"doc":"","ref":"AbacusSql.Completable.html#children/2","title":"AbacusSql.Completable.children/2","type":"function"},{"doc":"Returns a list of completion items that this schema offers. The passed context is a term that can be given to AbacusSql.Completion.autocomplete/2 .","ref":"AbacusSql.Completable.html#c:completable_children/1","title":"AbacusSql.Completable.completable_children/1","type":"callback"},{"doc":"","ref":"AbacusSql.Completable.html#t:context/0","title":"AbacusSql.Completable.context/0","type":"type"},{"doc":"","ref":"AbacusSql.Completable.html#t:schema/0","title":"AbacusSql.Completable.schema/0","type":"type"},{"doc":"","ref":"AbacusSql.Completable.Schema.html","title":"AbacusSql.Completable.Schema","type":"behaviour"},{"doc":"","ref":"AbacusSql.Completable.Schema.html#c:assoc_description/2","title":"AbacusSql.Completable.Schema.assoc_description/2","type":"callback"},{"doc":"","ref":"AbacusSql.Completable.Schema.html#c:assoc_display/2","title":"AbacusSql.Completable.Schema.assoc_display/2","type":"callback"},{"doc":"","ref":"AbacusSql.Completable.Schema.html#children/3","title":"AbacusSql.Completable.Schema.children/3","type":"function"},{"doc":"","ref":"AbacusSql.Completable.Schema.html#c:field_description/2","title":"AbacusSql.Completable.Schema.field_description/2","type":"callback"},{"doc":"","ref":"AbacusSql.Completable.Schema.html#c:field_display/2","title":"AbacusSql.Completable.Schema.field_display/2","type":"callback"},{"doc":"","ref":"AbacusSql.Completion.html","title":"AbacusSql.Completion","type":"module"},{"doc":"","ref":"AbacusSql.Completion.html#autocomplete/3","title":"AbacusSql.Completion.autocomplete/3","type":"function"},{"doc":"","ref":"AbacusSql.Completion.html#extract_schema_context/2","title":"AbacusSql.Completion.extract_schema_context/2","type":"function"},{"doc":"","ref":"AbacusSql.Completion.html#find_single_result_in_schema/3","title":"AbacusSql.Completion.find_single_result_in_schema/3","type":"function"},{"doc":"","ref":"AbacusSql.Completion.html#t:context/0","title":"AbacusSql.Completion.context/0","type":"type"},{"doc":"","ref":"AbacusSql.Completion.html#t:schema/0","title":"AbacusSql.Completion.schema/0","type":"type"},{"doc":"Represents a completion item that would appear in an autocompletion list. code - Code necessary to complete the expression from the last . filtered_code - Code necessary to complete the expression from the cursor position display - The name to display in the list description - A short line of documentation for the completion type - Schema or struct of that the code will return","ref":"AbacusSql.Completion.Item.html","title":"AbacusSql.Completion.Item","type":"module"},{"doc":"","ref":"AbacusSql.Scope.html","title":"AbacusSql.Scope","type":"module"},{"doc":"","ref":"AbacusSql.Scope.html#scope_join/3","title":"AbacusSql.Scope.scope_join/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.html","title":"AbacusSql.Term","type":"module"},{"doc":"","ref":"AbacusSql.Term.html#auto_join/3","title":"AbacusSql.Term.auto_join/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#binary_to_allowed_atom/2","title":"AbacusSql.Term.binary_to_allowed_atom/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#comb_variable_access/1","title":"AbacusSql.Term.comb_variable_access/1","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#convert_ast/4","title":"AbacusSql.Term.convert_ast/4","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#convert_ast_finalize/4","title":"AbacusSql.Term.convert_ast_finalize/4","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#find_assoc/2","title":"AbacusSql.Term.find_assoc/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#find_field/2","title":"AbacusSql.Term.find_field/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#find_join/3","title":"AbacusSql.Term.find_join/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#get_field/4","title":"AbacusSql.Term.get_field/4","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#get_join_source/2","title":"AbacusSql.Term.get_join_source/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#get_root/1","title":"AbacusSql.Term.get_root/1","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#get_schema_by_id/2","title":"AbacusSql.Term.get_schema_by_id/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#get_table_id/2","title":"AbacusSql.Term.get_table_id/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#parse/1","title":"AbacusSql.Term.parse/1","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#postprocess/3","title":"AbacusSql.Term.postprocess/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#preprocess/3","title":"AbacusSql.Term.preprocess/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#reduce_args/4","title":"AbacusSql.Term.reduce_args/4","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#rename_variables/2","title":"AbacusSql.Term.rename_variables/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#to_ecto_term/4","title":"AbacusSql.Term.to_ecto_term/4","type":"function"},{"doc":"","ref":"AbacusSql.Term.html#typeof/1","title":"AbacusSql.Term.typeof/1","type":"function"},{"doc":"Some functions for preprocessing","ref":"AbacusSql.Term.Pre.html","title":"AbacusSql.Term.Pre","type":"module"},{"doc":"","ref":"AbacusSql.Term.Pre.html#format_access/1","title":"AbacusSql.Term.Pre.format_access/1","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#inject_macro/6","title":"AbacusSql.Term.Pre.inject_macro/6","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#inject_schema/3","title":"AbacusSql.Term.Pre.inject_schema/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#inject_shortcut/6","title":"AbacusSql.Term.Pre.inject_shortcut/6","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#is_placeholder?/1","title":"AbacusSql.Term.Pre.is_placeholder?/1","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#macro/3","title":"AbacusSql.Term.Pre.macro/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#pattern_match/2","title":"AbacusSql.Term.Pre.pattern_match/2","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#pattern_match_ast/3","title":"AbacusSql.Term.Pre.pattern_match_ast/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#reduce_pattern_match_args/3","title":"AbacusSql.Term.Pre.reduce_pattern_match_args/3","type":"function"},{"doc":"","ref":"AbacusSql.Term.Pre.html#shortcut/3","title":"AbacusSql.Term.Pre.shortcut/3","type":"function"},{"doc":"","ref":"AbacusSqlTest.BlogPost.html","title":"AbacusSqlTest.BlogPost","type":"module"},{"doc":"","ref":"AbacusSqlTest.BlogPost.html#assoc_description/2","title":"AbacusSqlTest.BlogPost.assoc_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.BlogPost.html#assoc_display/2","title":"AbacusSqlTest.BlogPost.assoc_display/2","type":"function"},{"doc":"Callback implementation for AbacusSql.Completable.completable_children/1 .","ref":"AbacusSqlTest.BlogPost.html#completable_children/1","title":"AbacusSqlTest.BlogPost.completable_children/1","type":"function"},{"doc":"","ref":"AbacusSqlTest.BlogPost.html#field_description/2","title":"AbacusSqlTest.BlogPost.field_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.BlogPost.html#field_display/2","title":"AbacusSqlTest.BlogPost.field_display/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.BlogPost.Fields.html","title":"AbacusSqlTest.BlogPost.Fields","type":"module"},{"doc":"","ref":"AbacusSqlTest.Comment.html","title":"AbacusSqlTest.Comment","type":"module"},{"doc":"","ref":"AbacusSqlTest.Comment.html#assoc_description/2","title":"AbacusSqlTest.Comment.assoc_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.Comment.html#assoc_display/2","title":"AbacusSqlTest.Comment.assoc_display/2","type":"function"},{"doc":"Callback implementation for AbacusSql.Completable.completable_children/1 .","ref":"AbacusSqlTest.Comment.html#completable_children/1","title":"AbacusSqlTest.Comment.completable_children/1","type":"function"},{"doc":"","ref":"AbacusSqlTest.Comment.html#field_description/2","title":"AbacusSqlTest.Comment.field_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.Comment.html#field_display/2","title":"AbacusSqlTest.Comment.field_display/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.MacroModule.html","title":"AbacusSqlTest.MacroModule","type":"module"},{"doc":"","ref":"AbacusSqlTest.User.html","title":"AbacusSqlTest.User","type":"module"},{"doc":"","ref":"AbacusSqlTest.User.html#assoc_description/2","title":"AbacusSqlTest.User.assoc_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.User.html#assoc_display/2","title":"AbacusSqlTest.User.assoc_display/2","type":"function"},{"doc":"Callback implementation for AbacusSql.Completable.completable_children/1 .","ref":"AbacusSqlTest.User.html#completable_children/1","title":"AbacusSqlTest.User.completable_children/1","type":"function"},{"doc":"","ref":"AbacusSqlTest.User.html#field_description/2","title":"AbacusSqlTest.User.field_description/2","type":"function"},{"doc":"","ref":"AbacusSqlTest.User.html#field_display/2","title":"AbacusSqlTest.User.field_display/2","type":"function"},{"doc":"","ref":"AbacusSql.NoFieldOrAssociationFoundError.html","title":"AbacusSql.NoFieldOrAssociationFoundError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AbacusSql.NoFieldOrAssociationFoundError.html#message/1","title":"AbacusSql.NoFieldOrAssociationFoundError.message/1","type":"function"},{"doc":"","ref":"AbacusSql.UndefinedFunctionError.html","title":"AbacusSql.UndefinedFunctionError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"AbacusSql.UndefinedFunctionError.html#message/1","title":"AbacusSql.UndefinedFunctionError.message/1","type":"function"}]